clear all
clc
% clc;
randn('state',1); rand('state',1); %#ok<RAND>
caseIDs=1:10;
nrRuns = size(caseIDs, 2);
%% Generate CP tensor
% DIM = [200,200,3];     % Dimensions of data
% R = 5         % True CP rank
% DataType = 2;         % 1: Random factors   2: The deterministic factors (sin, cos, square)
%
% Z = cell(length(DIM),1);
% if DataType ==1
%     for m=1:length(DIM)
%           Z{m} =  gaussSample(zeros(R,1), eye(R), DIM(m));
%     end
% end
% if DataType == 2
%     for m=1:length(DIM)
%         temp = linspace(0, m*2*pi, DIM(m));
%         part1 = [sin(temp); cos(temp); square(linspace(0, 16*pi, DIM(m)))]';
%         part2 = gaussSample(zeros(DIM(m),1), eye(DIM(m)), R-size(part1,2))';
%         Z{m} = [part1 part2];
%         Z{m} = Z{m}(:,1:R);
%         Z{m} = zscore(Z{m});
%     end
% end

% X = double(ktensor(Z));

load('100100100R5.mat')

for TTT=1%:10
    %    strlbl=['0303_CP246_Iter500Lambda1_InitialR25_basketballNormal_V',num2str(TTT)];
    caseIDs=[ 5 ]
    for itnr = caseIDs
        %% parameters to setup the problem
        switch itnr
            case 1
                ObsRatio = 0.1
            case 2
                ObsRatio = 0.2
            case 3
                ObsRatio =  0.3
            case 4
                ObsRatio = 0.4
            case 5
                ObsRatio =  0.5
            case 6
                ObsRatio =  0.6
            case 7
                ObsRatio =  0.7
            case 8
                ObsRatio =  0.8
            case 9
                ObsRatio = 0.9
        end
        results.percentage_available(itnr) = ObsRatio;
        H = ones(size(X));
        [n1, n2, n3] = size(X);
        [I, J, K] = ind2sub([n1, n2, n3], find(H(:)));
        clear 'H';
        DIM = size(X);
        data = X(:);
        subs = double([I, J, K]);
        rp = randperm(length(data));
        traIdx=rp(1:round(ObsRatio*length(rp)));
        data_train = data(traIdx);
        T = zeros(size(X));
        T(traIdx) = double(data(traIdx));
        Omega=T;
        Omega(traIdx)=1;
        Omega=logical(Omega);
        subs_train = subs(traIdx,:);
        tstIdx=rp(round((ObsRatio)*length(rp))+1:end);
        data_test = data(tstIdx);
        subs_test = subs(tstIdx,:);
        n=size(X);
        
        %% parameters to setup the problem
        maxIter = 500;
        epsilon = 1e-10;
        nrRun = 0;
        InitialR= min(round(0.5*mean(size(X))),100);
        Lambda= 100;
        
        nrRun = nrRun +1;
        tic
        [Z,U,CPrank,w,RankChange,Wchange]   = TREL1_CP(...
            T,...                     % The incomplete matrix whose elements in Omega are used for estimating missing value;
            Omega,...                 % The index set of the obeserved elements: known 1, unkown, 0;
            Lambda,...                    % The parameter of the L1-norm regularzation term; always set it as 1;
            maxIter,...               % The maxiLambdam iterations;
            epsilon,...               % The stop tolerance of the error of approximation Z and input X on observed entries;
            InitialR);
        
        results.Rank(nrRun, itnr) = {CPrank};
        results.Methods(nrRun, itnr) = {'L1TRE_CP'};
        elapsed_time = toc;
        RSE= norm(Z(:)-X(:),'fro') /norm(X(:),'fro');
        err = Z(:) - X(:);
        rmse = sqrt(mean(err.^2));
        fprintf(1,'rmse  = %e\n',rmse);
        fprintf(1,'RSE  = %e\n',RSE);
        results.Lambda(nrRun, itnr) = Lambda;
        results.RMSE(nrRun, itnr) = rmse;
        results.RSE(nrRun, itnr) = RSE;
        results.Time(nrRun, itnr) = elapsed_time;
    end
    %    save(strlbl,'results', '-v7.3')
end