function [Z,U,TuckerRank,w,RankChange,Wchange] = TREL1_Tucker(T, Omega,Lambda, maxIter, epsilon,R)
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Created by Qiquan on 05/11/2015
% Revised by Qiquan on 08/04/2015
% Revised by Qiquan on 03/09/2016
% Revised by Qiquan on 09/09/2016
sizeT = size(T);
Weights_L= zeros(maxIter, 1);
Wchange=zeros(maxIter, R);
RankChange=zeros(maxIter, 1);
DimX=ndims(T);
X = T;
w=rand(R,1);
w_old=w;
for i = 1 : DimX
    U0{i} = rand(sizeT(i),R);
    temp=sqrt(sum(U0{i}.^2,1));
    U0{i}= U0{i}./((ones(size(U0{i},1),1))*temp);
end
U=U0{1};
V=U0{2};
X(~Omega) = mean(T(Omega));
%% Iteration Scheme

for k = 1: maxIter
    
    Xr =  X;
    % Updating U{i} and G
    
    for r= 1 : R
        if w(r) ~= 0
            index0=find(abs(w(1:r))>0);
            R0=length(index0);
            Xrn=Xr*V(:,r);
            u1=zeros(sizeT(1),1);
            for q=1:R0-1
                u1=u1 -U(:,index0(q))'*double(Xrn(:))*U(:,index0(q));
            end
            midU1 =(Xrn(:)+ u1)/(w(r));
            if   norm(midU1(:)) ~= 0
                U(:,r)= midU1/norm(midU1(:));
                
                Xrn=Xr'*U(:,r);
                u2=zeros(sizeT(2),1);
                for q=1:R0-1
                    u2=u2-V(:,index0(q))'*Xrn(:)*V(:,index0(q));
                end
                midU2 =(Xrn(:)+ u2)/(w(r));
                if   norm(midU2(:)) ~= 0
                    V(:,r)= midU2/norm(midU2(:));
               midw= U(:,r)*V(:,r)';
            DO=dot(Xr(:),midw(:));
            w(r) = soft(DO,Lambda);
            Weights_L(k,r)=w(r);
            Xr =  Xr - w(r)*midw;  % Residual of approximation
                end
            end
            

        end
    end
    Z =  X -Xr;            % Approximation Z aims to finally equal to ground truth M;
    X(~Omega) = Z(~Omega); % Update the missing part in X using approximated vaules in Z;
    
    %% Check the erro  norm(X(:) - Z(:))^2
    RankChange(k,1)=length(find(abs(w)>5e-3));
%     length(find((w)>eps));
    Wchange(k,1)=norm(abs(w)-abs(w_old))/norm(abs(w_old));
    w_old=w;
    
    % Update X
    if   mod(k+1, 10) == 0
        if Wchange(k,1) < epsilon
            break;
        end
    end
end
%% Estimate the real rank of the incomplete matrix X
%     if find(w==0)
index1=find(w/sum(w)>eps);
Noabs =length(index1);
index2=find(abs(w)/sum(abs(w))>eps);
ABSw =length(index2);
fprintf('********  size(find(w>0)) = %d \n \n ',length(find(w>0)));
if  Noabs > ABSw
    R=ABSw;
    w=w(index2);
    index=index2;
else
    R=Noabs;
    w=w(index1);
    index=index1;
end
TuckerRank=R;
w_old=w;
fprintf('******** L1MC-RF estimated rank = %d, iterations = %d******** \n \n ', TuckerRank,k);
U10=U(:,index(1:R));
U20=V(:,index(1:R));
U=U10;
V=U20;
TuckerR= R;
UV={U,V};
 function y = soft(x,T)
        if sum(abs(T(:)))==0
            y = x;
        else
            y = max(abs(x) - T, 0);
            y = sign(x).*y;
        end
    end
end