
% clc;
randn('state',1); rand('state',1); %#ok<RAND>
%define identifiers for the algorithms
L1TCTucker=1;
L1TCTucker_RF=2;
TuckerOpt_TuckerR=3;
TuckerOpt=4;
gHOI_TuckerR=5;
gHOI=6;
FRTC_TuckerR=7;
FRTC=8;
list_algorithms = [L1TCTucker,L1TCTucker_RF,TuckerOpt_TuckerR,TuckerOpt,gHOI_TuckerR,gHOI,FRTC_TuckerR,FRTC];
caseIDs=1:10;
nrRuns = size(caseIDs, 2);
nrAlgs = size(list_algorithms,2);
%% Generate Tucker tensor
% n = [200 200 200];
% r1 = 15;
% r2 = 18;
% r3 = 20;
% r = [r1, r2, r3];
% A = makeRandTensor( n, r );
% X=double(A);

load('200200200R151820.mat')

for TTT=1%:10
    %     strlbl=['0303_TuckerALL_Iter500Lambda4_505050R555_V',num2str(TTT)];
    caseIDs=[7 ]
    for itnr = caseIDs
        %% parameters to setup the problem
        switch itnr
            case 1
                ObsRatio = 0.1
            case 2
                ObsRatio = 0.2
            case 3
                ObsRatio =  0.3
            case 4
                ObsRatio = 0.4
            case 5
                ObsRatio =  0.5
            case 6
                ObsRatio =  0.6
            case 7
                ObsRatio =  0.7
            case 8
                ObsRatio =  0.8
            case 9
                ObsRatio = 0.9
        end
        results.percentage_available(itnr) = ObsRatio;
        H = ones(size(X));
        [n1, n2, n3] = size(X);
        [I, J, K] = ind2sub([n1, n2, n3], find(H(:)));
        clear 'H';
        DIM = size(X);
        data = X(:);
        subs = double([I, J, K]);
        rp = randperm(length(data));
        traIdx=rp(1:round(ObsRatio*length(rp)));
        data_train = data(traIdx);
        T = zeros(size(X));
        T(traIdx) = double(data(traIdx));
        Omega=T;
        Omega(traIdx)=1;
        Omega=logical(Omega);
        subs_train = subs(traIdx,:);
        tstIdx=rp(round((ObsRatio)*length(rp))+1:end);
        data_test = data(tstIdx);
        subs_test = subs(tstIdx,:);
        n=size(X);
        
        %% parameters to setup the problem
        maxIter = 500;
        epsilon = 1e-5
        nrRun = 0;
        Lambda = 100
        initialR= min(round(0.5*mean(size(X))),100);
        
        nrRun = nrRun +1;
        
        tic
        
        for iY = 1:3
            tic
            Yi_unfold = unfold_mode_n_Nthorder(T, iY, n);
            Yi_Omega = ones(size(Yi_unfold));
            Yi_Omega(Yi_unfold==0)=0;
            Yi_Omega=logical(Yi_Omega);
            
            [Z0,U,TuckerR0,w,RankChange,Wchange]= TREL1_Tucker(...
                Yi_unfold,...                     % The incomplete matrix whose elements in Omega are used for estimating missing value;
                Yi_Omega,...                 % The index set of the obeserved elements: known 1, unkown, 0;
                Lambda,...                    % The parameter of the L1-norm regularzation term; always set it as 1;
                maxIter,...               % The maxiLambdam iterations;
                epsilon,...               % The stop tolerance of the error of approximation Z and input X on observed entries;
                initialR);
            
            TuckerRank(iY)=TuckerR0;
            results.Rank(nrRun, itnr) = {TuckerRank};
            Z=refold_mode_n_Nthorder(Z0,iY, n);
        end
        
        results.Methods(nrRun, itnr) = {'L1TRE_Tucker'};
        elapsed_time = toc
        RSE= norm(Z(:)-X(:),'fro') /norm(X(:),'fro');
        err = Z(:) - X(:);
        rmse = sqrt(mean(err.^2));
        fprintf(1,'rmse  = %e\n',rmse);
        fprintf(1,'RSE  = %e\n',RSE);
        results.Lambda(nrRun, itnr) = Lambda;
        results.RMSE(nrRun, itnr) = rmse;
        results.RSE(nrRun, itnr) = RSE;
        results.Time(nrRun, itnr) = elapsed_time;
        %        save(strlbl,'results', '-v7.3')
    end
end