% copyright by Silvia Gandy, Tokyo Institute of Technology
% June, 2011

function Xunfold = unfold_mode_n_Nthorder(X, mode, N)
%unfold the mode-"mode" of orderX-way array X
% N = [n1, n2,... nN];
if nargin < 3
    N = size(X);
end
orderX = size(N,2);

if mode == 1
    dim2 = prod(N(2:orderX));
    Xunfold = reshape(X,N(1), dim2);
else
    perm = [mode, 1:(mode-1), (mode+1):orderX];
    dim2 = prod(N([1:(mode-1), (mode+1):orderX]));
    Xunfold = reshape(permute(X, perm), N(mode), dim2);
end    
end
